<?php 
namespace WOO_PRODUCT_TABLE_PRO\Inc\Features;

use WOO_PRODUCT_TABLE_PRO\Core\Base;
use WOO_PRODUCT_TABLE\Inc\Shortcode_Base;


class Variable_Product extends Shortcode_Base{
    public $default_poistion = 'woocommerce_single_product_summary';

    /**
     * It's table id, which actually stored in condifigure page.
     * But Actually it's come from configuration page setting
     * 
     * 
     *
     * @var int|string
     */
    public $table_id;

    /**
     * Table Position mean, location of showing table..  
     * In Variable Product Page, Where do u want to show Table.
     * 
     * By default, I will show table at 'woocommerce_single_product_summary' of WooCommerce 
     *
     * @var [type]
     */
    public $table_position;
    public $priority = 8;

    public $product_id;

    /**
     * Pass fail of Table id and table location 
     * 
     * It will regenrate at the table_in_product_page() method and
     * will use at the render method.
     *
     * @var boolean
     */
    public $status = false;

    public $behavior;
    
    protected $attributes = [];
    protected $childrens = [];
    protected $Product_Variable;

    public $product_inc_exc = false;
    public $product_inc_exc_ids = false;
    public $product_inc_ids = '';
    public $product_exc_ids = '';

    public $pageNumberKey = 'PageNumber';

    /**
     * To work on Variable product
     * By default using Shortcode
     * 
     * No need any more customization.
     *
     * @return void
     */
    public function handleTableOnVariableShortcode()
    {
        $this->filter('wpt_query_args'); 
        $this->action('wpt_load');
    }
    /**
     * Variable products Table enable
     * and run from here 
     *
     * @return void
     */
    public function run(){
        $enable_variable_table = apply_filters( 'wpt_variable_table', true );
        //To enable on Variable product default feature, We have to execute wpt_quer_args on by default
        $this->handleTableOnVariableShortcode();

        $this->table_position = $this->base_config['variation_table_position'] ?? $this->default_poistion;
        
        /**
         * In previous version, we added table in variable page using following hook.
         * But if a customer get/use new version of our plugin,
         * He need to removed this following hook.
         * Otherwise, there will show Double table. 
         * 
         * Why we don't remove from code, Actually for old user of free version.
         * Need that code actually.
         * 
         * @author Saiful Islam <codersaiful@gmail.com>
         */
        remove_action( 'woocommerce_single_product_summary', 'wpt_show_variation_table', 3 );

        $hook_action_possition = $this->table_position !== 'woocommerce_before_add_to_cart_form' ? 'woocommerce_single_product_summary' : 'woocommerce_before_add_to_cart_form';
        //woocommerce_single_product_summary
        //woocommerce_before_add_to_cart_form
        $this->action( $hook_action_possition, 1, 3, 'table_in_product_page' );

        $this->action('wpt_load');
        
    }

    public function table_in_product_page(){
        global $product;

        if( $product->get_type() !== 'variable' ) return;
        // If not create any variation yet then return @added by Fazle Bari 
        if( empty( $product->get_available_variations() ) ) return;

        $this->product_id = $product->get_id();

        /**
         * Product Variable and Attribute will be need
         * When we will call to action hook wp_load
         * Where I will manage Mainly column setting and column ammount
         * I will add new column based on product's attribute wise 
         * column as well as column_setting for thes added new column
         * 
         */
        $this->Product_Variable = new \WC_Product_Variable( $this->product_id ); 
        $this->attributes = $this->Product_Variable->get_variation_attributes();


        $table_id = $this->table_on_variable;
        $table_id = apply_filters( 'wpto_variation_table_id', $table_id );
        $table_id = apply_filters( 'wpt_variation_table_id', $table_id );
        $this->table_id = is_numeric( $table_id ) ? (int) $table_id : false;
        
        
        if( $this->table_id && ! empty( $this->table_position ) ){
            $this->status = true;
            remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 );
            
            if ( $this->table_position == 'woocommerce_single_product_summary' ) {
                $this->action($this->table_position,1,$this->priority,'render_table');
                // add_action( $this->table_position, 'wpt_woo_product_table_as_variation', 4);
            }else if ( $this->table_position == 'woocommerce_before_add_to_cart_form' ) {
				add_action('woocommerce_before_add_to_cart_form',[$this,'render_table']);
			}else{
                $this->priority = -999;
                $this->action($this->table_position,1,$this->priority,'render_table');
                // add_action( $this->table_position, 'wpt_woo_product_table_as_variation', -999);
            }
        }
        
    }

    public function enable_exlude_include_control(){
        $this->product_inc_exc = $this->base_config['vt_prod_inc_exc'] ?? '';
        if(empty($this->product_inc_exc)) return;

        $this->product_inc_exc_ids = $this->base_config['vt_prod_inc_exc_ids'] ?? '';
        if( empty( $this->product_inc_exc_ids ) || ! is_string( $this->product_inc_exc_ids ) ) return;
        $this->product_inc_exc_ids = explode(",", $this->product_inc_exc_ids);

        if( 
            ( $this->product_inc_exc == 'vt_product_exc' && in_array( $this->product_id, $this->product_inc_exc_ids ) ) ||
            ( $this->product_inc_exc == 'vt_product_inc' && ! in_array( $this->product_id, $this->product_inc_exc_ids ) )
         ){
            $this->status = false;
            add_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 );
        }

        
    }
    /**
     * How I will get table_id, position in here.
     * Because, this method will call after call $this->table_in_product_page
     * which called using action hook woocommerce_single_product_summary inside run method.
     * 
     * 
     *
     * @return void
     */
    public function render_table(){
        $this->filter( 'wpt_query_args' );

        /**
         * Pagination feature added to Variable product.
         * Actually it's newly added for variable product.
         * 
         * @since 8.3.0.0
         * @author Saiful Islam <codersaiful@gmail.com>
         */
        $this->filter( 'wpt_paginate_args' );
        $this->enable_exlude_include_control();
        if( ! $this->status ) return;
        echo do_shortcode( "[Product_Table id='{$this->table_id}']" );
        
    }
    public function wpt_paginate_args( $pagin_args ){
        $permalink = get_the_permalink( $this->product_id );
        $sign = strpos($permalink,'?') ? "&": '?';
        $pagin_args['base'] =  $permalink . $sign . $this->pageNumberKey . '=%#%';
        return $pagin_args;
    }

    /**
     * Change and set custom property on $shortcode
     * using action hook 'wpt_load'
     *
     * @param object $shortcode
     * @return void
     */
    public function wpt_load( $shortcode ){
        
        global $product;
        
        if( ! is_object( $product ) ) return;
        if( ! is_product() ) return;
        if( $product->get_type() !== 'variable' ) return;
        // If not create any variation yet then return @added by Fazle Bari 
        if( empty( $product->get_available_variations() ) ) return;

        $this->product_id = $product->get_id();

        $this->Product_Variable = new \WC_Product_Variable( $this->product_id ); 
        $this->attributes = $this->Product_Variable->get_variation_attributes();
        

        /**
         * On variable product, I disabled Pagination
         * using following property
         * $shortcode->pagination_ajax = 'no_ajax'
         * 
         * @since 8.3.0.0
         */
        $shortcode->pagination_ajax = 'no_ajax';
        $this->behavior = $shortcode->args['behavior'] ?? '';     
        if($this->behavior == 'normal') return;        
        //if it get it till here, we will remove add to cart button from variable product.
        remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 );


        $maArr = [];
        
        $shortcode->search_box = false;
        $shortcode->search_n_filter['cf_search_box'] = 'no';

        //Unset action column
        unset($shortcode->_enable_cols['attribute']);
        unset($shortcode->_enable_cols['product_title']);
        unset($shortcode->_enable_cols['variations']);
        // unset($shortcode->_enable_cols['variation_name']);

        
        $arrtibutes = array_keys( $this->attributes );
        if( empty( $arrtibutes ) ){
            $shortcode->table_display = false;
            add_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 );
            return;
        }

        foreach( $arrtibutes as $key ){
            $label = wc_attribute_label($key);
            $maArr[$key] = $label;
            $shortcode->column_settings[$key] = [
                'type' => 'single_variation',
                'type_name' => 'Single Variation',
                'variation_name' => $label,
                'tag_class' => 'auto-generated_variation_column wpt-auto-gen_product_id' . $shortcode->table_id,
            ];
        }

        $maArr = apply_filters('wpt_variation_attr', $maArr);
        
        //Mini filter handle on Variable product has fixed here.
        $shortcode->search_n_filter['filter'] = array_keys( $maArr );

        $quick_qty = $shortcode->_enable_cols['quick_qty'] ?? false;
        $action = $shortcode->_enable_cols['action'] ?? false;
        if( $quick_qty ){
            unset($shortcode->_enable_cols['quantity']);
            unset($shortcode->_enable_cols['action']);
        }else{
            $shortcode->_enable_cols['action'] = 'action';
        }
        $final_target = ! empty( $quick_qty ) ? $quick_qty : $action;
        

        $target_key = isset( $shortcode->_enable_cols['quantity'] ) ? 'quantity' : $final_target;
        $target_key = $shortcode->_enable_cols['variation_name'] ?? $target_key;
        
        $shortcode->_enable_cols = $this->array_insert_before( $shortcode->_enable_cols,$maArr,$target_key );
        unset($shortcode->_enable_cols['variation_name']);
    }

    public function wpt_query_args( $args ){
        
        $this->behavior = $args['behavior'] ?? '';
        if($this->behavior == 'normal') return $args;

        if( empty($this->Product_Variable) ){
            $_ID = get_the_ID();
            if( empty( $_ID ) || ! is_product() ) return $args;
            $product_includes = [];
            $this->Product_Variable = new \WC_Product_Variable( $_ID );
            // $this->Product_Variable = $this_post_variable->get_children();
        }

        if( empty($this->Product_Variable) ) return $args;
        //Args Management
        $product_includes = [];
        $this->childrens = $this->Product_Variable->get_children();
        foreach( $this->childrens as $per ){
            $product_includes[$per] = $per;
        }
        $args['post__in'] = $product_includes;
        $args['post_type'] = array( 'product', 'product_variation' );
        unset($args['tax_query']);
        $args['paged'] = $_GET[$this->pageNumberKey] ?? 1;
        return $args;
    }

    

}